/**
  Generated Main Source File
    UV_16F1705
  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F1705
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"

// O[oϐ錾
double Vdd=3.0;                 // ddl[V]
unsigned long ADC;              // ADCi[ϐ
double Output;                  // ZT[o͓d
unsigned int UVI;               // UV_Indexϐ

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                 // t\Wo͊֐Ƃ
}

/*
     Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // ϐ
    ADC = 0;
    Output = 0;
    UVI = 0;    

    // LCD
    lcd_init();             // LCD    
    
    while (1)
    {
        // Add your application code
        
        ADC = ADC_GetConversion(channel_AN2);   // ADCϊ(10rbg\)ǂݏo        
        Output = ADC * Vdd / 1023;              // ZT[o͓dlϊ(10rbg\)
        
        if (Output < 1)                         // ZT[o  1[V]Ȃ
            UVI = 0;                            // UV Index'0'

        else                                    // ZT[o  1[V]Ȃ
            UVI = (int)(8.33 * Output - 8.33);  // UV Index(int^)Z            
            
        lcd_cmd(0x80);                          // LCD1s
            printf("UVI= %2d", UVI);            // UV Index\     

        lcd_cmd(0xC0);                          // LCD2s
            if (UVI < 3)                        // UV Index  3̏ꍇ
                printf("Weak UV");              // 'Weak UV'\                        

            if ((UVI >= 3)&&(UVI < 5))          // 3  UV Index  5̏ꍇ
                printf("Alert  ");                // 'Alert'\        
        
            if ((UVI >= 5)&&(UVI < 8))          // 5  UV Index  8̏ꍇ
                printf("Caution");              // 'Caution'\

            if (UVI >= 8)                       // UV Index  8̏ꍇ      
                printf("Warning");             // 'Warning'\         

        __delay_ms(1000);                       // LCD\(1sec)        
    }
}

/**
 End of File
*/